<div style="background: #f1e05a; color: black; padding: 12px 24px; border-radius: 6px;">
⚠ This project is new and is under active development. Do not use this in production. Visual designs, logos, assets, and etc are not final. ⚠
</div>

# <center>ButterflyVu</center>

<center>ButterflyVu is a new documentation template built on the Astro Web Framework.</center>

## Running
> `bun` will be used over `npm` in instructions.
### Requirements
 - Git
 - Bun <span style="font-size: 8px; opacity: 0.5">1</span> <span style="font-size: 8px; opacity: 0.5">2</span>

<p style="font-size: 10px; opacity: 0.5">1. SudoVanilla recommends using the Bun package manager for Astro projects.</p>
<p style="font-size: 10px; opacity: 0.5">2. If you plan to use Bun, NodeJS is not required to be installed, which is why it's not listed as a requirement. (Tested)</p>

### Clone Repository
Start by cloning the repository to somewhere on your device using the `git` command:
```bash
git clone https://ark.sudovanilla.org/korbs/butterflyvu/
cd ./butterflyvu/
```

### Install Packages
Install required packages so you can run the project:
```bash
bun install
```

### Run
Run the website with the run command:
```bash
bun start
```

The website should start running at [http://localhost:2014](http://localhost:2014). 

If the website is not running and an error appears, troubleshoot the problem by reading the error and try again. If the problem persist, submit an issue.

## Hosting
### Requirements
It is expected for the server admin to use the Docker method, as it is recommended, so please install the Docker Engine.

 - [Install Docker Engine for Windows]() (WSL Method)
 - [Install Docker Engine for macOS]() (Homebrew Method)
 - [Install Docker Engine for Linux]()

SudoVanilla does NOT recommend using the Docker Desktop application, as it is proprietary software.

### Docker Compose (Recommended)
A Docker Compose file is provided that can be used without needing to clone the repository. Download the file to it's folder somewhere on your disk and run it.

```
services:
  butterflyvu:
    image: ark.sudovanilla.org/korbs/butterlyvu:amd64
    volumes:
      - ./config.json:/app/config.json
      - ./docs/:/app/src/content/docs/
      - ./dists/:/app/dist/

  nginx:
    image: nginx:latest
    restart: always
    ports:
      - 4242:80
    volumes:
      - ./dists/:/usr/share/nginx/html/
```
___

<center>A <a href="https://sudovanilla.org/">SudoVanilla</a> Project</center>